cap program drop regs_arci
program define regs_arci, eclass
	args regtype keeplist dem

	
	egen p_id = group(inmate_id)

	local i 1
	foreach var of varlist $outcomes{
		local labelvar : variable label `var'
		
		if "`regtype'" == "ols" {				
			if "`dem'" == "" {
				reghdfe `var' $fs_out `dem' , a($time_fe ) cluster(p_id clin_id night_shift)
				local ar_ci = ""
				if `i' == 1 {
					regsave using "$data/regs.dta", pval replace addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
				}
				else {
					regsave using "$data/regs.dta", pval append addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
				}
			}
			else if "`dem'" == "$demogs" {
				reghdfe `var' $fs_out `dem' , a($time_fe ) cluster(p_id clin_id night_shift)
				local ar_ci = ""
				if `i' == 1 {
					di "`i': `regtype' : `dem'"
					regsave using "$data/regs.dta", pval replace addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
				}
				else {
					di "`i': `regtype' : `dem' : `var'"
					di "`ar_ci'"
					regsave using "$data/regs.dta", pval append addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
				}
			}
		}

		else {
			di "twostepCheck: `i': `var'"
			twostepweakiv 2sls `var' ($fs_out = z_$fs_out ) i.$time_fe `dem', cluster(p_id clin_id night_shift)
			local ar_ci = "`e(ar_cset)'"
			ivreghdfe `var' ($fs_out = z_$fs_out ) `dem' , a($time_fe ) cluster(p_id clin_id night_shift)
			
			if `i' == 1 {
				di "`i': `regtype' : `dem'"
				regsave using "$data/regs.dta", pval replace addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
			}
			else {
				di "`i': `regtype' : `dem' : `var'"
				di "`ar_ci'"
				regsave using "$data/regs.dta", pval append addlabel(ar_ci, "`ar_ci'", outcome, "`var'", outcomename, "`labelvar'")
			}
		}
		
		
		local ++i
		
	}


	use "$data/regs.dta", clear
	keep if var == "$fs_out" 
	drop var r2
	gen order = _N - _n
	sort order
	drop order
	

	if 1 == inlist("`regtype'", "ols") {
		
		mkmat coef, mat(b) rownames(outcome)
		mkmat stderr, mat(se) rownames(outcome)
		mkmat pval, mat(pval) rownames(outcome)
		
		mat B = b'
		mat SE = se'
		mat P = pval'

		mat b = B
		mat stderr = SE
		mat p = P
		ereturn post b
		ereturn matrix se = stderr
		eststo

		
	}
	else {
		replace ar_ci = usubinstr(ar_ci, " ", "", .)
		replace ar_ci = usubinstr(ar_ci, "[", "", .)
		replace ar_ci = usubinstr(ar_ci, "]", "", .)
		replace ar_ci = usubinstr(ar_ci, "...", "", .)
		replace ar_ci = usubinstr(ar_ci, "etiregrid", "", .)
		split ar_ci, gen(ci) parse(,)
		
		capture confirm variable ci1
			if !_rc {
				ren ci1 ci_lower
			}
			else {
				gen ci_lower = .
			}
		capture confirm variable ci2 
			if !_rc {
				ren ci2 ci_upper
			}
			else {
				gen ci_upper = .
			}
		destring ci_lower ci_upper, replace force
		
		mkmat coef, mat(b) rownames(outcome)
		mkmat stderr, mat(se) rownames(outcome)
		mkmat pval, mat(pval) rownames(outcome)
		mkmat ci_lower , mat(ci_l) rownames(outcome)
		mkmat ci_upper , mat(ci_u) rownames(outcome)
		
		mat B = b'
		mat SE = se'
		mat CIL = ci_l'
		mat CIU = ci_u'
		mat P = pval'

		mat b = B
		mat stderr = SE
		mat p = P
		ereturn post b
		ereturn matrix se = stderr 
		
		*ereturn post B
		eststo 
		*estadd mat SE
		estadd mat CIL
		estadd mat CIU
		*estadd mat P, replace
		
	}

	estadd local t_fe "Yes"
	if "`dem'" == "" {
		estadd local controls "No"
	}
	else {
		estadd local controls "Yes"
	}
		
end		
